%Camera to position

clc;
clear all;
close all;

display = 0;

%constants 
baseline = .3;% [m]
heightZ = 3;   % [m]
focalLength = 43; % [m]
cameraHeight = 33; %[m]
RGB = 1;

thresholdNum = 50;

delay = .0001;

errorData = [0, 0, 0, 0, 0, 0, 0, 0, 0,0,0,0];




%Include source files in path
addpath(genpath('../src'))

%Initialization Parameters
server_ip   = '127.0.0.1';     %IP address of the Unity Server
server_port = 55001;           %Server Port of the Unity Sever

client = tcpclient(server_ip,server_port);
fprintf(1,"Connected to server\n");

%--------------------------------------------------------------------------------------

% x,y,z,yaw[z],pitch[y],roll[x]
pose = [0,cameraHeight+3,0,90,-90,3]; % move TennisBall out of the way
unityLink(client,pose);

%TopCamera Baseline
pose = [0,cameraHeight,baseline/2,90,-90,0]; % move camera 
unityLink(client,pose);

unityImage = unityLink(client,pose);

baselineTop = unityImage;
imwrite(baselineTop,"baselineTop.png");

%SideCamera Baseline
pose = [0,cameraHeight,-baseline/2,90,-90,1]; % move camera 
unityLink(client,pose);

unityImage = unityLink(client,pose);

baselineSide = unityImage;
imwrite(baselineSide,"baselineSide.png");

%Enter Loop



for lengthX = -11.88:0.88:11.88
    for widthY = -5.02:0.5:5.02

       %Dispalay Actual Position         
        pose = [widthY,heightZ,lengthX,90,-90,3]; % move TennisBall
        unityLink(client,pose);

%----------------------------------------------------------------------------------------------------------        
        %Camera Position Side
        pose = [0,cameraHeight,-baseline/2,90,-90,1]; % move camera position 1
        unityImage = unityLink(client,pose);
        %imwrite(unityImage,"Left.png")
        TenisBallOnly = unityImage - baselineSide; %imsubtract

        % use RGB values here instead grey Scales a problem
        %[row,col] = find(rgb2gray(TenisBallOnly) > 0);%find tennis ball indexes 
        [row,col] = find(TenisBallOnly(:,:,RGB) > thresholdNum);%find tennis ball indexes 

        xSide = mean(col);
        ySide = mean(row);
        centers = [xSide ySide];
        %imwrite(unityImage,"BottomView.png");

        if(display == 1)
            imshow(unityImage)
            pause(delay)
            imshow(TenisBallOnly);
            %imshow(baselineSide);
            pause(delay)
            viscircles(centers, 1,'Color','r');
            pause(delay)
        end

 %       LeftImageCentroid = ['(xLeft,yLeft)', num2str(xLeft),',',num2str(yLeft)];
 %       disp(LeftImageCentroid);
 %       pause(0.5)
%----------------------------------------------------------------------------------------------------------
  %Camera position Top
        pose = [0,cameraHeight,baseline/2,90,-90,0]; % move camera position 2 
        unityImage = unityLink(client,pose);
        %imwrite(baselineSide,"Right.png");

        TenisBallOnly = unityImage - baselineTop;

        % use RGB values here instead grey Scales a problem
        %[row,col] = find(rgb2gray(TenisBallOnly) > 0);%find tennis ball indexes 
        [row,col] = find(TenisBallOnly(:,:,RGB) > thresholdNum);%find tennis ball indexes 

        xTop = mean(col);
        yTop = mean(row);
        centers = [xTop yTop];
        %imwrite(unityImage,"TopView.png");

        if(display == 1)
            imshow(unityImage)
            pause(delay)
            imshow(TenisBallOnly);
            %imshow(baselineTop);
            pause(delay)
            viscircles(centers, 1,'Color','b');
            pause(delay)
        end

%        RightImageCentroid = ['(xRight,yRight)', num2str(xRight),',',num2str(yRight)];
 %       disp(RightImageCentroid)
 %       pause(.5)
%------------------------------------------------------------------------------------------------------------
        %Calculate 3D position
        [X,Y,Z] = find3DOrthogonal(xTop, yTop, ySide);
        errorX = ((((X))-lengthX)/lengthX)*100;
        errorY = ((((Y))-widthY)/widthY)*100;
        errorZ = (((Z)-heightZ)/heightZ)*100;
        Xsub = (X)-lengthX;
        Ysub = (Y)-widthY;
        Zsub = (Z)-heightZ;
        errorData(end+1,:) = [lengthX, widthY, heightZ, X, Y, Z, errorX, errorY, errorZ,Xsub,Ysub,Zsub];
        if(display == 1)
            X = ['Actual: [',num2str(lengthX),',',num2str(widthY),',',num2str(heightZ),']'];
            disp('Postion')
            disp(X);

            position = ['Calculated: [',num2str((X)),',',num2str((Y)),',',num2str((Z)),']'];
            disp(position);
    
            
            error = ['error: [',num2str(errorX),'%, ',num2str(errorY),'%, ',num2str(errorZ),'%]'];
            disp(error)
            disp(' ');
        end



        pause(delay/2)
    end 
end 



figure
scatter3(0,0,13,'*');
hold on
scatter3(1,9.5,0,'*');
scatter3(errorData(:,1),errorData(:,2),errorData(:,7))
title("X error @ h = ",num2str(heightZ))

figure
scatter3(0,0,13,'*');
hold on
scatter3(1,9.5,0,'*');
scatter3(errorData(:,1),errorData(:,2),errorData(:,8))
title("Y error @ h = ",num2str(heightZ))

figure
scatter3(0,0,13,'*');
hold on
scatter3(1,9.5,0,'*');
scatter3(errorData(:,1),errorData(:,2),errorData(:,9))
title("Z error @ h = ",num2str(heightZ))

%--------------------------------------------------------------------------------------

%Close Gracefully
fprintf(1,"Disconnected from server\n");
